/*****************************************************************************
  IR 
	=38[kHz], 1/2 ǥ塼ƥ
  ߼ȿ=76.18[kHz], ߼=0.013[ms]
*****************************************************************************/
#include <avr/io.h>
#include <avr/interrupt.h>
#include <avr/pgmspace.h>
#include <avr/wdt.h>
#include <avr/eeprom.h> 
#include <util/delay.h>

#include "ir.h"
#include "common.h"
#include "main.h"
#include "fs.h"


#define LEARN_TIMEOUT 7

static volatile unsigned char ir_flag=IR_FLAG_STOP;
static volatile unsigned char ir_bit, ir_bit_prev, ir_led;
static volatile unsigned int ir_data_pos;
static volatile unsigned int ir_data_cnt;
static volatile unsigned char ir_duty=0;
static volatile unsigned char ir_fn;
static volatile unsigned char bit_len=0, bit_data=0;
//static volatile unsigned int len_head_pt;
static uint8_t *len_head_pt;
static volatile unsigned char timeoutFlip;
static volatile unsigned char ir_longtime_flag;
static volatile unsigned int worddata;
static unsigned long waitTimeout;
static unsigned char keyCancelled;

volatile unsigned char ir_data[IR_SIZE];
volatile unsigned int ir_data_size;
volatile unsigned char sleepFlip;
static char ir_repeat;

volatile char ir_last_result = IR_RESULT_NONE;
volatile char ir_receiveCancelDisable=0;
unsigned char irregularFlag;
unsigned int short_on, short_off, long_on, long_off;

// 󥰥
volatile unsigned char standard[2];
volatile unsigned char run;
volatile unsigned char odd;

// 
void ir_init(void) {
	// ݡ
	IR_OUT_DDR |=  _BV(IR_OUT_BIT);
	IR_IN_DDR  &= ~_BV(IR_IN_BIT);
	
	// 1 76kHz 
	GTCCR |= BV(TSM);     // 곫
	TCCR0B |= BV(CS00);   // 0 ʬʤ
	TCCR0A |= BV(WGM01);  // 0 ư
	OCR0A  = 210;         // 0 A 쥸(1/2duty, 16MHz/210=76.18kHz)
	TIMSK  |= BV(OCIE0A); // 0 A ߵ
	GTCCR &= ~BV(TSM);    // 꽪λ
}

//
// 38kHz Ĵ, 2ܤμȿǳ
// ߼ȿ=76.18[kHz], ߼=0.013[ms]
//
#pragma GCC optimize ("O3")
ISR(SIG_OUTPUT_COMPARE0A) {
	//wdt_reset();

	// ॢ
	timeoutFlip=1;
	sleepFlip=1;

	// 
	// ǥ塼ƥ=1/2 : if (ir_duty==2), OCR0A = 210;
	ir_duty ^= 1;
	if (ir_led && ir_duty) { IR_OUT_PORT |=  _BV(IR_OUT_BIT); } 
	else { IR_OUT_PORT &= ~_BV(IR_OUT_BIT); }

	//
	// 
	//
	if (ir_flag==IR_FLAG_SENDING) {
		//----- ̤в
		if (ir_data_cnt < worddata) {	ir_data_cnt++; return; }
		//----- λ
		if (ir_data_pos>=ir_data_size || ir_data_pos>=IR_SIZE) { ir_flag=IR_FLAG_SEND_END; return; }
		//----- ֤вᤷƤΤ IR-LED ȿž
		// ̤줿 RAM ɤ
		odd = odd ^ 1;

	output_standard_data:
		if (run!=0) {
			worddata = standard[odd];
			run--;
			if (run==0) ir_data_pos++;  // κǽӥåȤϸ˥󥯥
			goto end_runlength_read; 
		}

		worddata = ir_data[ir_data_pos];

		if (((unsigned char)worddata & 0b11000000) == 0b11000000) {
			run = worddata & 0b00111111; goto output_standard_data; 
		}

		ir_data_pos++; // Ƚ˥󥯥

		if (worddata<64) standard[odd] = worddata;
		
		if (worddata & 0b0000000010000000) {
			// 2ХȽ
			worddata &= 0b00111111;
			worddata  = worddata << 8;
			worddata |= ir_data[ir_data_pos];
			ir_data_pos++;
		}

	end_runlength_read:

		// worddata  0 ʤϤȿž˽λ
		if (worddata==0) {
			ir_flag = IR_FLAG_SEND_END;
			return;
		}
		ir_data_cnt=1;
		ir_led ^= 0x01;
	} //  

	// 󥵡ɤ߼
	ir_bit = (~IR_IN_PIN) & _BV(IR_IN_BIT);

	//
	// 
	//
	if (ir_flag==IR_FLAG_RECEIVING) {
		// 
		if (ir_bit == ir_bit_prev) {
			// Ʊä
			ir_data_cnt++;
			if (ir_data_cnt>16383) 	goto ir_end_ok; // Ĺ֤Ϣ³(нλ)
			if (ir_data_cnt>IR_TIME_LIMIT) {
				ir_longtime_flag |= 1;
				if ((ir_longtime_flag & 0b100) && mode==1) goto ir_end_ok; // N ܤϢ³(ｪλ)
			}
		} else {
			// Ȱۤʤ
			odd = odd ^ 1;
			unsigned char s = standard[odd];

			// 
			if (ir_data_cnt>3) {
        if (ir_bit) ir_data_cnt+=3; else ir_data_cnt-=3;
      }

			// ե饰
      if (ir_longtime_flag & 1) ir_longtime_flag = ir_longtime_flag << 1;

			// ͤƱϥ󥰥
			if (ir_data_cnt<(unsigned int)s+4 && ir_data_cnt>(unsigned int)s-4
					&& run<63 && ir_data_pos>16) { run++; goto end_runlength_w; }
			if (run!=0) { ir_data[ir_data_pos] = 0b11000000 | run; ir_data_pos++; run=0; } // ݽФ
			if (ir_data_cnt<64) standard[odd] = ir_data_cnt;
			// 2ХȽ
			if (ir_data_cnt>127) {
				ir_data[ir_data_pos] = (ir_data_cnt>>8 | 0b10000000);
				ir_data_pos++;
				ir_data[ir_data_pos] = (ir_data_cnt & 0xff);
			} else {
				ir_data[ir_data_pos] = (ir_data_cnt & 0xff);
			}
			ir_data_pos++;

		end_runlength_w:

			ir_data_cnt=0;

			// 4ХȽ񤯲ǽ
			if (ir_data_pos >= IR_SIZE-5) goto ir_end_err; // ir_data[] ꥵĶ
		}
		ir_bit_prev = ir_bit;
		return;
	}

	// 
	// Ե
	//
	if (ir_flag==IR_FLAG_RECEIVE_WAIT) {
		if (ir_bit) {
			ir_bit_prev=BV(PB_SENSOR);
			ir_flag=IR_FLAG_RECEIVING;
			int1_disable();
		}
		return;
	}
	return;

 ir_end_ok:
	// ǽݽФ
	if (run!=0) { ir_data[ir_data_pos] = 0b11000000 | run; ir_data_pos++; }

	// ｪλξϥ
	ir_data_size = ir_data_pos;
	goto ir_end;

	// ۾ｪλξϥ0ˤ
 ir_end_err:
	if (mode==3) ir_data_size = ir_data_pos; else ir_data_size = 0;

	// λ̽
 ir_end:
	ir_data[ir_data_pos] = 0;
	ir_flag=IR_FLAG_RECEIVE_END;
	return;
} // SIGNAL
#pragma GCC optimize ("Os")

///
/// 
///
void ir_start_receive(unsigned char fn) {
	unsigned int i;
	if (ir_flag != IR_FLAG_STOP) return; // IR ԵְʳǤϼ¹Ԥʤ
	ir_flag = IR_FLAG_RECEIVE_WAIT;      // ޤʤ˥ե饰ΩƤ
	waitTimeout = 0;                     // Ե֤ǤΥॢ
	// ѿ
	ir_fn = fn;
	ir_data_pos = 0;
	ir_data_cnt = 0;
	irsens_on(); // ŸON
	_delay_ms(100);
	for (i=0; i<IR_SIZE; i++) {
		ir_data[i]=0;
	}
	keyCancelled=0;
	ir_longtime_flag=0;

	standard[0] = standard[1] = run = 0;
	odd = 1; // ǽ H  0 ڤؤꡢ0鵭Ͽ
}

///
/// 
///
void ir_start_send(char repeat) {
 // IR ԵְʳǤϼ¹Ԥʤ
	if (ir_flag != IR_FLAG_STOP) { return;}
	cli();
	ir_flag = IR_FLAG_SENDING;           // ޤʤ˥ե饰ΩƤ

	// ѿ
	ir_data_pos = 0;

	ir_bit = 1;
	ir_led = 0;
	ir_repeat = repeat;
	if (ir_repeat==0) ir_repeat = 2;

	standard[0] = standard[1] = run = 0;
	odd = 1;                   //  0 ڤؤ	
	ir_data_cnt=1; worddata=0; // ir_data_cnt>worddata ǳϤɬפ

	sei();
	int1_disable();
}

// IR Ե֤᤹
void ir_stop(void) {
	ir_flag=IR_FLAG_STOP;
}

//
// IR ݡ󥰸ƤӽФ
// (ؽλľνӥ⡼ɤɲ)
void ir_polling() {

	// Ǥʤֳ LED 
	if (ir_flag!=IR_FLAG_SENDING) {
		IR_OUT_PORT &= ~_BV(IR_OUT_BIT);
		ir_led=0;
	}

	// λľ
	if (ir_flag==IR_FLAG_SEND_END) {
		if (--ir_repeat>0) {
			_delay_ms(40+20);
			ir_flag = IR_FLAG_STOP;
			ir_start_send(ir_repeat);
			return;
		}
		// beep_start(1);
		ir_flag = IR_FLAG_STOP;
		return;
	}

	// ǤǤʤХ1 
	if (ir_flag!=IR_FLAG_RECEIVING && ir_flag!=IR_FLAG_SENDING) {
		int1_enable();
	}

	// ؽԵ֤ǤΥॢȽ(Ǥ⥭󥻥뤹)
	if (ir_flag==IR_FLAG_RECEIVE_WAIT) { 
		if (timeoutFlip) { timeoutFlip=0; waitTimeout++; }
		// ir_receiveCancelDisable ꤵƤȤϥ󥻥뤷ʤ
		if (ir_receiveCancelDisable==0) {
			if (waitTimeout > 72000*LEARN_TIMEOUT) { ir_flag=IR_FLAG_RECEIVE_END; }
			if (!(PINB & BV(PB_SW))) { ir_flag=IR_FLAG_RECEIVE_END; keyCancelled=1;}
		}
	}
	// ؽλľ
	if (ir_flag==IR_FLAG_RECEIVE_END) {
		irsens_off(); // Ÿ OFF
		// ΥϽλ
		if (ir_data_pos<IR_DATALEN_MIN)  {
			// ir_start_receive(ir_fn);
			ir_flag=IR_FLAG_STOP;
			if (keyCancelled==0) { errorbeep_start(2); longPush=0; } // Υξ ERRORBEEP*2
			ir_last_result = IR_RESULT_TOOSHORT; // ɽѤ˷̤Ͽ
			return;
		}
		// СϽ񤫤ʤ
		if (ir_data_size==0)  {
			ir_flag=IR_FLAG_STOP;
			if (keyCancelled==0) { errorbeep_start(3); longPush=0; } // Сξ ERRORBEEP*3
			ir_last_result = IR_RESULT_NORAM; // ɽѤ˷̤Ͽ
			return;
		}
		longPush=0;

		if (ir_save(ir_fn) != FS_OK) {
			ir_flag=IR_FLAG_STOP;
			errorbeep_start(4);               // DISK FULL ξ ERRORBEEP*3
			ir_last_result = IR_RESULT_NOROM; // ɽѤ˷̤Ͽ
			return;
		}

		ir_flag=IR_FLAG_STOP;
		longbeep_start(mode);
		ir_last_result = IR_RESULT_SUCCESS; // ɽѤ˷̤Ͽ
		return;
	}
}

// ir_flag ξ֤֤
unsigned char ir_flag_status(void) {
	return ir_flag;
}

// expandRead(), expandWrite() ѤΥѥ᡼ν
void expandParameterInitHelper(void) {
	odd=1; standard[0]=standard[1]=run=0; // expandRead() ѥ᡼
}


// p  2Хͤɤإ (ɤ p Τʤ)
// ƤӽФ¦ǽɬ: expandParameterInitHelper()
unsigned int expandRead(unsigned char** p) {
	unsigned int res;

	odd = odd ^ 1;

 expandRead_OutpurStandardValue:
	if (run>0) {
		run--;
		if (run==0) (*p)++; // κǽӥåȤϸ˥󥯥
		return standard[odd]; 
	}
	res = **p;

	if (((unsigned char)res & 0b11000000)==0b11000000) {
		run = res & 0b00111111; 
		goto expandRead_OutpurStandardValue; 
	}
	(*p)++; // Ƚ˥󥯥

	if (res<64) { standard[odd] = res; }

	if (res & 0b10000000) {
		res &= 0b00111111;
		res = res << 8;
		res |= **p;
		(*p)++;
	}
	return res;
}

// p 2Хͤ񤭽Фإ(񤤤 p Τʤ)
// ƤӽФ¦ǽɬ: 	expandParameterInitHelper()
void expandWrite(unsigned char **p, unsigned int v) {

	odd = odd ^ 1;

	if (v<standard[odd]+4 && v>standard[odd]-4 && run<63) { run++; return; }
	if (run!=0) { **p = 0b11000000 | run; run=0; (*p)++; } // ݽФ
	if (v<64) standard[odd] = v;

	if (v>127) {
		**p     = ((v>>8) | 0b10000000);
		(*p)++;
		**p = v & 0xff;
		(*p)++;
		return;
	} else {
		**p = v & 0xff;
		(*p)++;
		return;
	}
}


// IR 
// ̸ǡ 32767 ʾͤޤǤϤʤ
// 󥰥̺Ѥߤ RAM  16383 ʾͤϴޤޤʤ
unsigned char ir_save(unsigned char fn) {
	unsigned char *pt;
	unsigned int i;
	unsigned char result;

	int1_disable();

	// ѿ
	bit_len=0;
	bit_data=0;

	// IR ǡ¸߳ǧ
	if (ir_data_size<IR_DATALEN_MIN) { int1_enable(); return FS_NOTFOUND; }

	// ʿˡ
	{
		unsigned int total,total1, total2, short_total;
		unsigned char *pt_end, *pt_start;
		unsigned char short_cnt=0, long_cnt=0;

		// ü롣ûѥ륹 L/H ¤
		// 4ǡʬɤ
		pt = (unsigned char*)ir_data;	// ¾Υѥ᡼ɬפ
		//odd=1; standard[0]=standard[1]=run=0;
		expandParameterInitHelper();

		// for (i=0; i<4; i++) if (*pt>127) pt+=2; else pt++; // 췿ɤ
		for (i=0; i<4; i++) expandRead(&pt); // ɤ
		short_total  = expandRead(&pt);
		short_total += expandRead(&pt);

		pt_end = pt_start = pt;
		while (pt<ir_data+ir_data_size-1) {
			total1 = expandRead(&pt);
			if (total1==0) break;    // 0 üξˤʤ褦, 0 ȯ
			total2 = expandRead(&pt);
			if (total2==0) break;    // 0 üξˤʤ褦, 0 ȯ
// if (total > short_total*4) { break; } // debug: ȥ
			if (short_total > total1+total2) short_total=total1+total2;
			pt_end = pt;
		}

		// 64 ѥ륹ʿѤ
		short_on = short_off = long_on = long_off = 0;
		pt = pt_start; // ¾Υѥ᡼ɬפ
		// odd=1; standard[0]=standard[1]=run=0; // ¾Υѥ᡼
		expandParameterInitHelper();

		total1=0;
		while(total1<4096) {
			unsigned int first, second;
			if (pt>=pt_end) {
				// ü褿Ƭ
				if (long_cnt==0)  long_cnt=64;
				if (short_cnt==0) short_cnt=64;
				pt = pt_start; // ¾Υѥ᡼ɬפ
				// odd=1; standard[0]=standard[1]=run=0; // ¾Υѥ᡼
				expandParameterInitHelper();
			}
			first  = expandRead(&pt);
			second = expandRead(&pt);
			total = first + second;

			// ۾ĹϻѤʤ
			if (total < (short_total<<2)) {
				if (total > short_total+(short_total>>2)) {
					// ĹӥåȽ
					if (long_cnt<64)  { long_on+=first; long_off+=second; long_cnt++;  }
				} else {
					// ûӥåȽ
					if (short_cnt<64) { short_on+=first; short_off+=second; short_cnt++; }
				}
			}	// ۾ĹϻѤʤ
			if (short_cnt>=64 && long_cnt>=64) break;
			total1++;			// ̵¥롼ɻ(4096)
		} // while(1)

	} // ʿˡ

	long_on  = (long_on>>6);
	long_off = (long_off>>6);
	short_on = (short_on>>6);
	short_off = (short_off>>6);

	/* ưŪޡ	*/
	unsigned char MARGIN_SHORT_ON;
	unsigned char MARGIN_LONG_ON;
	unsigned char MARGIN_SHORT_OFF;
	unsigned char MARGIN_LONG_OFF;

	MARGIN_SHORT_ON = (short_on>>2);   if (MARGIN_SHORT_ON<7) MARGIN_SHORT_ON=7;
	MARGIN_LONG_ON  = (long_on>>2);    if (MARGIN_LONG_ON<7) MARGIN_LONG_ON=7;
	MARGIN_SHORT_OFF = (short_off>>2); if (MARGIN_SHORT_OFF<7) MARGIN_SHORT_OFF=7;
	MARGIN_LONG_OFF = (long_off>>2);   if (MARGIN_LONG_OFF<7) MARGIN_LONG_OFF=7;

	// 饤ȥץ
	result = fs_wopen(fn);
	if (result != FS_OK) { int1_enable(); return result; }
	
	// EEPROM ˥ѥ᡼񤭹
	fs_write_b(0); // ޥåʥС(̾0)
	fs_write_w(0); // fs_write_w(ir_data_size); // ̤
	fs_write_w(short_on);
	fs_write_w(short_off);
	fs_write_w(long_on);
	fs_write_w(long_off);

	// 񤭹߽
	pt = (unsigned char*)ir_data;// ¾Υѥ᡼ɬפ
	// odd=1; standard[0]=standard[1]=run=0; // ¾Υѥ᡼
	expandParameterInitHelper();

	while (pt < ir_data+ir_data_size) {
		unsigned int on, off;
		on  = expandRead(&pt);
		if (pt >= ir_data+ir_data_size) { off=0; goto data_end; } // on ӥåȤǥǡԤ
		off = expandRead(&pt);
		// ûӥåȽ
		if ((int)on>(int)short_on-MARGIN_SHORT_ON  && (int)on<(int)short_on+MARGIN_SHORT_ON &&
				(int)off>(int)short_off-MARGIN_SHORT_OFF && (int)off<(int)short_off+MARGIN_SHORT_OFF) {
			bit_data = bit_data<<1;
			bit_data &= 0b11111110;
			goto bit_compress; 
		}
		// ĹӥåȽ
		if ((int)on>(int)long_on-MARGIN_LONG_ON   && (int)on<(int)long_on+MARGIN_LONG_ON && 
				(int)off>(int)long_off-MARGIN_LONG_OFF && (int)off<(int)long_off+MARGIN_LONG_OFF) {
			bit_data = bit_data<<1;
			bit_data |= 0b00000001;
			goto bit_compress; 
		}
		// ʳȽ
	data_end:
		if (bit_len>0) write_8bit();
		fs_write_b(on  >> 8);	fs_write_b(on  & 0xff); // -̤ν
		fs_write_b(off >> 8);	fs_write_b(off & 0xff); // -̤ν

		if (on==0 || off==0) break;
		continue;

	bit_compress:
		// ӥåȰ
		if (bit_len==0) {
			len_head_pt=fs_pt; // ߡξϿ
			fs_write_b(0x00);  // 1Хȶ뤿˥ߡͤ񤤤Ƥ
		}
		bit_len++;
		if ((bit_len & 7)==0) fs_write_b(bit_data);
		if (bit_len==127) write_8bit();
	} // while
	// ǸݤФ
	if (bit_len>0) write_8bit();
	result = fs_wclose();

	// 񤭹ߤ˼Ԥ̵̤Ǥν񤭽Фߤ
	if (result!=FS_OK || fs_size>ir_data_size) {
		result = fs_wopen(fn);
		fs_write_b(0x01); // ̵̤ǵϿϥޥåʥС1ˤ
		pt = (unsigned char*)ir_data;
		// expandParameterInitHelper();// expandRead() ѥ᡼
		while (pt < ir_data+ir_data_size) {
			// fs_write_b(expandRead(&pt));
			fs_write_b(*pt);
			pt++;
		}
		result = fs_wclose();
	} // ̵̤Ǥν񤭽Ф

	// 񤭤ߤϥå⵭Ͽ
	if (result==FS_OK) {
		unsigned char sum = getCheckSum(fn);
		if (fs_wopen(fn+128)==FS_OK) {
			fs_write_b(sum); // å fn+128 ˵Ͽ
			result = fs_wclose();
		}
	}

	int1_enable();
	return result;
}

// ̥ӥåݤФ
void write_8bit(void) {
	if ((bit_len % 8) != 0) {
		bit_data = bit_data << (7-((bit_len-1)&7));
		fs_write_b(bit_data);
	}
	// ϰϳˤϽ񤫤ʤ
	if (len_head_pt<EEPROM_FS+FS_SIZE-3) eeprom_write_byte(len_head_pt, bit_len |= 0b10000000);
	bit_len=0;
}


// IR Ÿ
// ̾ϥեֹꤹ ir_data[] Ÿ롣
// ûϵݡ -> 10ʲʤǽ餫EEPROM˵Ͽʤ

unsigned char ir_load(unsigned char fn) {
	//unsigned int short_on, short_off, long_on, long_off;
	unsigned char *pt = (unsigned char *)ir_data;
	unsigned char data;
	unsigned char result;

	int1_disable();

	// ѿ
	bit_len=0;
	bit_data=0;

	result = fs_search(fn);
	if (result != FS_OK) { int1_enable(); return result; }

	// åγǧ
	{
		unsigned char sum = 0xff;
		if (fs_search(fn+128)==FS_OK) sum = fs_read_b();
		if (sum != getCheckSum(fn)) { int1_enable(); return FS_CHECKSUMERROR; }
	}

	// եΥץ
	result = fs_search(fn);
	//if (result != FS_OK) { int1_enable(); return result; }
	unsigned int writeSize = fs_size-11;
	// expandWrite ѥѥ᡼
	// odd=1; standard[0]=standard[1]=run=0;
	expandParameterInitHelper();

	// EEPROM ѥ᡼ɤ
	if (fs_read_b()==1) goto rawLoad;           // ޥåʥС1ξ̤̤ǵϿƤ
	fs_read_w(); // ir_data_size = fs_read_w(); // ̤ѡpt Ǻƥ
	short_on     = fs_read_w();
	short_off    = fs_read_w();
	long_on      = fs_read_w();
	long_off     = fs_read_w();

	irregularFlag = 0;
	unsigned int  totalBitCount = 0;

	// EEPROM  ir_data Ÿ
	int fscnt=0; // ե륷ƥफɤХȿ
	while (fscnt<writeSize && pt<=ir_data+IR_SIZE-2-1) {
		data = fs_read_b(); fscnt++;

		// ӥåŸ
		if (bit_len>0) {
			unsigned char cnt=8;
			while (cnt>0 && bit_len>0) {
				// ir_data ϰϥå
				// (1+2) + (1+2) + ǽݽФ + ü = 8ХȽ񤯲ǽ
				// ϰϤ򥪡С鳰¦ while ⽪λ
				if (pt >= ir_data+IR_SIZE-8-1) goto expand_force_end;
				// Ÿ (MSB ˱ƽ񤭹)
				if ((data & 0b10000000) == 0) {
					expandWrite(&pt, short_on);
					expandWrite(&pt, short_off);
				} else {
					expandWrite(&pt, long_on);
					expandWrite(&pt, long_off);
				}
				totalBitCount++;
				cnt--; bit_len--; 
				data = data<<1;
			}
			continue;
		}	// ӥåŸޤ

		// Ϣ³ӥåȥ
		if ((data & 0b10000000) != 0) {
			bit_len = data & 0b01111111;
			if (bit_len) continue; // 0b10000000 Ǥ̵¥롼ɻ
		}
		
		// ʳǡ
		// int ͤ
		worddata = (data<<8) | fs_read_b(); fscnt++;
		expandWrite(&pt, worddata);
		totalBitCount++;
		if (totalBitCount>2 && pt<ir_data+ir_data_size && irregularFlag<255) irregularFlag++;
	}
 expand_force_end:

	// ǽݽФ
	if (run!=0) { *pt = 0b11000000 | run; pt++; }

 raw_end:

	// ir_data  0ǽü
	*pt = 0;
	pt++;
	ir_data_size = pt-ir_data;

	int1_enable();
	return FS_OK;

 rawLoad:
	// ¸줿ͤɤ
	while (!fs_EOF() && pt<=ir_data+IR_SIZE-2-1) {
		// expandWrite(&pt, fs_read_b());
		*pt = fs_read_b();
		pt++;
	}
	goto raw_end;
}

// IR 
void ir_delete(unsigned char fn) {
	fs_delete(fn);
}

//
// ʸѿ16ʸ
//
/*
unsigned char* strHex(unsigned char *p, unsigned int c) {
	p[0] = ((c>>4) < 10) ? (c>>4) + '0' : (c>>4) + 'A' - 10;
	p[1] = ((c & 0x0f) < 10) ? (c & 0x0f) + '0' : (c & 0x0f) + 'A' - 10;
	p[2] = '\0';
	return p;
}
*/
